security:
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'

    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: identifier
        t2u_provider:
            entity:
                class: App\Entity\User
                property: loginToken
        admin_provider:
            entity:
                class: App\Entity\Admin
                property: email
        api_user_provider:
            entity:
                class: App\Entity\ApiUser
                property: identifier
    firewalls:
        dev:
            pattern: ^/(_(profiler|wdt)|css|images|js)/
            security: false

        api:
            pattern: ^/api2
            provider: api_user_provider
            stateless: true
            custom_authenticator: App\Security\ApiKeyAuthenticator

        admin:
            pattern: ^/(saml/acs$|admin(?:/.*)?$)
            provider: admin_provider
            custom_authenticator: App\Security\EnterpriseAuthenticator
            entry_point: App\Security\AdminFrontDoor

        api_v2:
            pattern: ^/api/v2
            stateless: true
            provider: t2u_provider
            custom_authenticators:
              - App\Security\TokenAuthenticator

        main:
            pattern: ^/
            lazy: true
            security: false
    access_control:
      - { path: ^/realms, roles: PUBLIC_ACCESS }
      # prevent anonymous users from accessing everything except /realms/* and /
      - { path: ^/purchase, roles: ROLE_USER }
      - { path: ^/admin, roles: ROLE_ADMIN }
      # - { path: ^/profile, roles: ROLE_USER }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
